diff --git a/lib/hive/web/app_bundle.rb b/lib/hive/web/app_bundle.rb
new file mode 100644
index 00000000..5a2176d3
--- /dev/null
+++ b/lib/hive/web/app_bundle.rb
@@ -0,0 +1,584 @@
+# frozen_string_literal: true
+
+require "fileutils"
+require "digest"
+require "net/http"
+require "openssl"
+require "rubygems/package"
+require "securerandom"
+require "timeout"
+require "tmpdir"
+require "uri"
+require "zlib"
+
+require "hive"
+require "hive/bounded_subprocess"
+require "hive/paths"
+
+module Hive
+  module Web
+    # Resolves and installs the version-matched Rails application bundle used
+    # by local (non-Docker) `hive web`. The gem intentionally excludes `web/`;
+    # gem/Homebrew/AUR installs acquire the matching GitHub release asset
+    # (`hive-web-<version>.tar.gz`) into `Hive::Paths.web_app_home`.
+    #
+    # Resolution order for `#resolve!`:
+    #   1. `HIVEBOX_WEB_APP_DIR` (explicit override; Docker and tests)
+    #   2. Current managed bundle (stamped with `Hive::VERSION`)
+    #   3. Source checkout `web/` next to the gem lib tree
+    #   4. Download + install the matching release asset
+    #
+    # Install is staged, Bundler-verified, then atomically swapped. A failed
+    # refresh leaves any previous working bundle intact; a failed first
+    # install leaves no half-provisioned target.
+    class AppBundle
+      ENV_APP_DIR = "HIVEBOX_WEB_APP_DIR"
+      VERSION_STAMP_NAME = ".hive-web-version"
+      RAILS_MARKER = File.join("config", "application.rb")
+      ARCHIVE_BASENAME_PREFIX = "hive-web-"
+      DEFAULT_CONNECT_TIMEOUT = 10
+      DEFAULT_READ_TIMEOUT = 120
+      DEFAULT_BUNDLE_TIMEOUT = 600
+      DEFAULT_CHECKSUM_VERIFY_TIMEOUT = 60
+      MAX_ARCHIVE_BYTES = 128 * 1024 * 1024
+      MAX_CHECKSUM_ASSET_BYTES = 1024 * 1024
+      MAX_ARCHIVE_ENTRIES = 20_000
+      MAX_ARCHIVE_ENTRY_BYTES = 64 * 1024 * 1024
+      MAX_ARCHIVE_EXPANDED_BYTES = 256 * 1024 * 1024
+
+      class Error < Hive::Error; end
+
+      attr_reader :messages
+
+      def initialize(
+        version: Hive::VERSION,
+        data_home: nil,
+        source_app_dir: nil,
+        env: ENV,
+        downloader: nil,
+        bundler: nil,
+        tar_reader: nil,
+        http_factory: nil,
+        subprocess_runner: nil,
+        connect_timeout: DEFAULT_CONNECT_TIMEOUT,
+        read_timeout: DEFAULT_READ_TIMEOUT,
+        bundle_timeout: DEFAULT_BUNDLE_TIMEOUT,
+        max_archive_bytes: MAX_ARCHIVE_BYTES,
+        max_archive_entries: MAX_ARCHIVE_ENTRIES,
+        max_archive_entry_bytes: MAX_ARCHIVE_ENTRY_BYTES,
+        max_archive_expanded_bytes: MAX_ARCHIVE_EXPANDED_BYTES
+      )
+        @version = version.to_s
+        @data_home = data_home
+        @source_app_dir = source_app_dir
+        @env = env
+        @downloader = downloader
+        @bundler = bundler || method(:default_bundle_install)
+        @tar_reader = tar_reader
+        @http_factory = http_factory
+        @subprocess_runner = subprocess_runner || Hive::BoundedSubprocess.method(:capture3)
+        @connect_timeout = connect_timeout
+        @read_timeout = read_timeout
+        @bundle_timeout = bundle_timeout
+        @max_archive_bytes = max_archive_bytes
+        @max_archive_entries = max_archive_entries
+        @max_archive_entry_bytes = max_archive_entry_bytes
+        @max_archive_expanded_bytes = max_archive_expanded_bytes
+        @messages = []
+      end
+
+      # Return a usable Rails app directory, installing the managed bundle
+      # when needed. Raises `AppBundle::Error` when no path can be resolved.
+      def resolve!(install: true)
+        if (explicit = explicit_app_dir)
+          return explicit
+        end
+
+        if current_managed_bundle?
+          return managed_app_dir
+        end
+
+        if (source = source_checkout_app_dir)
+          return source
+        end
+
+        raise Error, missing_bundle_message unless install
+
+        ensure_installed!
+        managed_app_dir
+      end
+
+      # True when a stamped managed bundle matching `@version` is present.
+      def current_managed_bundle?
+        rails_app?(managed_app_dir) && installed_version == @version
+      end
+
+      def installed_version
+        path = version_stamp_path
+        return nil unless File.file?(path)
+
+        File.read(path).strip
+      rescue SystemCallError
+        nil
+      end
+
+      def managed_app_dir
+        @data_home ? File.join(@data_home, "web-app") : Hive::Paths.web_app_home
+      end
+
+      def version_stamp_path
+        File.join(managed_app_dir, VERSION_STAMP_NAME)
+      end
+
+      def archive_basename(version = @version)
+        "#{ARCHIVE_BASENAME_PREFIX}#{version}.tar.gz"
+      end
+
+      def release_asset_url(version = @version)
+        "https://github.com/#{Hive::REPO_OWNER}/#{Hive::REPO_NAME}/releases/download/v#{version}/#{archive_basename(version)}"
+      end
+
+      # Bundler installs managed web gems below the app tree rather than into
+      # the invoking CLI's GEM_HOME. Source checkouts and explicit Docker/test
+      # overrides keep their normal development environment.
+      def runtime_env(app_dir)
+        return {} unless File.expand_path(app_dir.to_s) == File.expand_path(managed_app_dir)
+
+        bundle_env(managed_app_dir)
+      end
+
+      # Install or refresh the managed bundle for `@version`. Idempotent when
+      # the current stamp already matches.
+      def ensure_installed!(source: nil)
+        return managed_app_dir if current_managed_bundle? && source.nil?
+
+        if source
+          install_from_directory!(source)
+        else
+          install_from_release!
+        end
+        managed_app_dir
+      end
+
+      # Install from an already-extracted Rails tree (tests / offline fixtures).
+      def install_from_directory!(source_dir)
+        source_dir = File.expand_path(source_dir.to_s)
+        unless rails_app?(source_dir)
+          raise Error, "web app source at #{source_dir} is missing #{RAILS_MARKER}"
+        end
+
+        stage_and_swap! do |staging|
+          copy_tree(source_dir, staging)
+        end
+      end
+
+      # Download the matching release archive and install it.
+      def install_from_release!(url: release_asset_url)
+        Dir.mktmpdir("hive-web-dl-") do |tmpdir|
+          archive_path = File.join(tmpdir, archive_basename)
+          checksums_path = File.join(tmpdir, "SHA256SUMS")
+          download_asset(checksums_url(url), checksums_path, max_bytes: MAX_CHECKSUM_ASSET_BYTES)
+          verify_checksums_signature!(url, checksums_path, tmpdir)
+          download_asset(url, archive_path, max_bytes: @max_archive_bytes)
+          verify_archive_checksum!(archive_path, checksums_path)
+          extract_and_install!(archive_path)
+        end
+      end
+
+      # Extract a local `.tar.gz` and install it into the managed path.
+      def extract_and_install!(archive_path)
+        if File.size(archive_path) > @max_archive_bytes
+          raise Error, "#{File.basename(archive_path)} archive is too large " \
+            "(max #{@max_archive_bytes} bytes)"
+        end
+
+        Dir.mktmpdir("hive-web-extract-") do |extract_root|
+          extract_archive!(archive_path, extract_root)
+          rails_root = find_rails_root(extract_root)
+          unless rails_root
+            raise Error, "archive does not contain a Rails app (missing #{RAILS_MARKER})"
+          end
+
+          stage_and_swap! do |staging|
+            copy_tree(rails_root, staging)
+          end
+        end
+      end
+
+      def rails_app?(dir)
+        !dir.to_s.empty? && File.file?(File.join(dir, RAILS_MARKER))
+      end
+
+      private
+
+      def explicit_app_dir
+        raw = @env[ENV_APP_DIR].to_s
+        return nil if raw.empty?
+
+        dir = File.expand_path(raw)
+        return dir if rails_app?(dir)
+
+        @messages << "HIVEBOX_WEB_APP_DIR=#{dir} does not contain #{RAILS_MARKER}"
+        nil
+      end
+
+      def source_checkout_app_dir
+        candidates = []
+        candidates << @source_app_dir if @source_app_dir
+        # lib/hive/web/app_bundle.rb → repo_root/web
+        candidates << File.expand_path("../../../web", __dir__)
+        candidates.find { |dir| rails_app?(dir) }
+      end
+
+      def stage_and_swap!
+        target = managed_app_dir
+        parent = File.dirname(target)
+        FileUtils.mkdir_p(parent)
+
+        staging = "#{target}.staging.#{Process.pid}.#{SecureRandom.hex(4)}"
+        backup = nil
+        begin
+          FileUtils.rm_rf(staging)
+          FileUtils.mkdir_p(staging)
+          yield staging
+
+          unless rails_app?(staging)
+            raise Error, "staged web app is missing #{RAILS_MARKER}"
+          end
+
+          @bundler.call(staging)
+
+          # Stamp last so a partial install is never considered current.
+          File.write(File.join(staging, VERSION_STAMP_NAME), "#{@version}\n")
+
+          if File.exist?(target)
+            backup = "#{target}.prev.#{Process.pid}.#{SecureRandom.hex(4)}"
+            File.rename(target, backup)
+          end
+          File.rename(staging, target)
+          FileUtils.rm_rf(backup) if backup
+          @messages << "installed web app bundle #{@version} at #{target}"
+          target
+        rescue StandardError
+          FileUtils.rm_rf(staging) if staging && File.exist?(staging)
+          if backup && File.exist?(backup) && !File.exist?(target)
+            File.rename(backup, target)
+          end
+          raise
+        ensure
+          FileUtils.rm_rf(staging) if staging && File.exist?(staging)
+          FileUtils.rm_rf(backup) if backup && File.exist?(backup) && File.exist?(target)
+        end
+      end
+
+      def copy_tree(source, dest)
+        FileUtils.mkdir_p(dest)
+        Dir.children(source).each do |entry|
+          next if entry == VERSION_STAMP_NAME || entry == "." || entry == ".."
+
+          src = File.join(source, entry)
+          FileUtils.cp_r(src, File.join(dest, entry), preserve: true)
+        end
+      end
+
+      def extract_archive!(archive_path, dest_root)
+        dest_root = File.expand_path(dest_root)
+        FileUtils.mkdir_p(dest_root)
+        entry_count = 0
+        expanded_bytes = 0
+
+        open_tar(archive_path) do |tar|
+          tar.each do |entry|
+            entry_count += 1
+            if entry_count > @max_archive_entries
+              raise Error, "archive contains too many entries (max #{@max_archive_entries})"
+            end
+            validate_tar_entry!(entry, dest_root)
+            dest = File.join(dest_root, entry.full_name)
+
+            if entry.directory?
+              FileUtils.mkdir_p(dest)
+            elsif entry.file?
+              entry_size = Integer(entry.header.size)
+              if entry_size > @max_archive_entry_bytes
+                raise Error, "archive entry is too large: #{entry.full_name.inspect} " \
+                  "(max #{@max_archive_entry_bytes} bytes)"
+              end
+              expanded_bytes += entry_size
+              if expanded_bytes > @max_archive_expanded_bytes
+                raise Error, "archive expanded contents are too large " \
+                  "(max #{@max_archive_expanded_bytes} bytes)"
+              end
+              FileUtils.mkdir_p(File.dirname(dest))
+              File.open(dest, "wb", entry.header.mode & 0o755) do |out|
+                while (chunk = entry.read(1024 * 64))
+                  out.write(chunk)
+                end
+              end
+              # Strip setuid/setgid/sticky; keep owner rwx only as recorded.
+              File.chmod(entry.header.mode & 0o755, dest)
+            else
+              raise Error, "archive contains unsupported entry type for #{entry.full_name.inspect}"
+            end
+          end
+        end
+      end
+
+      def open_tar(archive_path, &block)
+        if @tar_reader
+          @tar_reader.call(archive_path, &block)
+          return
+        end
+
+        Zlib::GzipReader.open(archive_path) do |gz|
+          Gem::Package::TarReader.new(gz, &block)
+        end
+      rescue Zlib::Error, Gem::Package::TarInvalidError => e
+        raise Error, "invalid web app archive: #{e.message}"
+      end
+
+      def validate_tar_entry!(entry, dest_root)
+        name = entry.full_name.to_s
+        if name.empty?
+          raise Error, "archive contains an entry with an empty path"
+        end
+        if name.start_with?("/") || name.match?(%r{\A[A-Za-z]:[\\/]})
+          raise Error, "archive entry has absolute path: #{name.inspect}"
+        end
+        if name.split("/").include?("..")
+          raise Error, "archive entry escapes staging root: #{name.inspect}"
+        end
+        if entry.symlink? || entry.header.typeflag == "2" || entry.header.typeflag == "1"
+          raise Error, "archive contains link entry (rejected): #{name.inspect}"
+        end
+
+        dest = File.expand_path(File.join(dest_root, name))
+        unless dest == dest_root || dest.start_with?("#{dest_root}#{File::SEPARATOR}")
+          raise Error, "archive entry escapes staging root: #{name.inspect}"
+        end
+      end
+
+      def find_rails_root(extract_root)
+        return extract_root if rails_app?(extract_root)
+
+        # Single versioned wrapper directory (e.g. hive-web-0.3.2/...) is OK.
+        children = Dir.children(extract_root).reject { |n| n.start_with?(".") }
+        return nil unless children.length == 1
+
+        candidate = File.join(extract_root, children.first)
+        return candidate if File.directory?(candidate) && rails_app?(candidate)
+
+        nil
+      end
+
+      def checksums_url(asset_url)
+        sibling_asset_url(asset_url, "SHA256SUMS")
+      end
+
+      def sibling_asset_url(asset_url, basename)
+        uri = URI.parse(asset_url)
+        uri.path = File.join(File.dirname(uri.path), basename)
+        uri.query = nil
+        uri.fragment = nil
+        uri.to_s
+      end
+
+      def download_asset(url, dest_path, max_bytes:)
+        if @downloader
+          @downloader.call(url, dest_path)
+        else
+          default_download(url, dest_path, max_bytes: max_bytes)
+        end
+        unless File.file?(dest_path)
+          raise Error, "download did not create #{File.basename(dest_path)}"
+        end
+        if File.size(dest_path) > max_bytes
+          FileUtils.rm_f(dest_path)
+          raise Error, "#{File.basename(dest_path)} download is too large (max #{max_bytes} bytes)"
+        end
+        dest_path
+      end
+
+      def default_download(url, dest_path, max_bytes: @max_archive_bytes)
+        uri = URI.parse(url)
+        unless uri.is_a?(URI::HTTP) || uri.is_a?(URI::HTTPS)
+          raise Error, "web app download URL must be http(s); got #{url.inspect}"
+        end
+
+        part_path = "#{dest_path}.part.#{Process.pid}.#{SecureRandom.hex(4)}"
+        fetch_with_redirects(uri) do |response|
+          unless response.is_a?(Net::HTTPSuccess)
+            code = response.respond_to?(:code) ? response.code : "?"
+            raise Error, "failed to download web app bundle from #{url} (HTTP #{code})"
+          end
+
+          length = Integer(response["content-length"], exception: false)
+          if length && length > max_bytes
+            raise Error, "#{File.basename(dest_path)} download is too large (max #{max_bytes} bytes)"
+          end
+
+          downloaded = 0
+          File.open(part_path, "wb", 0o600) do |file|
+            response.read_body do |chunk|
+              downloaded += chunk.bytesize
+              if downloaded > max_bytes
+                raise Error, "#{File.basename(dest_path)} download is too large (max #{max_bytes} bytes)"
+              end
+              file.write(chunk)
+            end
+          end
+        end
+        File.rename(part_path, dest_path)
+        dest_path
+      rescue SocketError, Timeout::Error, Errno::ECONNREFUSED, Errno::EHOSTUNREACH,
+             Errno::ENETUNREACH, OpenSSL::SSL::SSLError, Net::OpenTimeout,
+             Net::ReadTimeout => e
+        raise Error, "failed to download web app bundle from #{url}: #{e.class}: #{e.message}"
+      ensure
+        FileUtils.rm_f(part_path) if defined?(part_path) && part_path
+      end
+
+      def fetch_with_redirects(uri, limit: 5, &block)
+        raise Error, "too many redirects downloading web app bundle" if limit <= 0
+
+        http = @http_factory ? @http_factory.call(uri) : Net::HTTP.new(uri.host, uri.port)
+        http.use_ssl = uri.scheme == "https"
+        http.open_timeout = @connect_timeout
+        http.read_timeout = @read_timeout
+        request = Net::HTTP::Get.new(uri.request_uri)
+        request["User-Agent"] = "hive-cli/#{@version}"
+        http.request(request) do |response|
+          case response
+          when Net::HTTPRedirection
+            location = response["location"].to_s
+            raise Error, "redirect without Location header" if location.empty?
+
+            redirected = URI.join(uri.to_s, location)
+            unless redirected.is_a?(URI::HTTP) || redirected.is_a?(URI::HTTPS)
+              raise Error, "web app redirect URL must be http(s); got #{redirected}"
+            end
+            if uri.scheme == "https" && redirected.scheme == "http"
+              raise Error, "refusing HTTPS to HTTP redirect downloading web app bundle"
+            end
+            return fetch_with_redirects(redirected, limit: limit - 1, &block)
+          else
+            return block.call(response)
+          end
+        end
+      end
+
+      def verify_archive_checksum!(archive_path, checksums_path)
+        basename = File.basename(archive_path)
+        pattern = /\A([a-f0-9]{64})  (?:\.\/)?#{Regexp.escape(basename)}\s*\z/
+        matches = File.foreach(checksums_path).filter_map { |line| line.match(pattern)&.[](1) }.uniq
+        if matches.empty?
+          raise Error, "SHA256SUMS does not contain #{basename}"
+        end
+        if matches.length > 1
+          raise Error, "SHA256SUMS contains conflicting entries for #{basename}"
+        end
+
+        actual = ::Digest::SHA256.file(archive_path).hexdigest
+        return if actual == matches.first
+
+        raise Error, "checksum mismatch for #{basename}"
+      rescue SystemCallError => e
+        raise Error, "could not verify #{basename}: #{e.message}"
+      end
+
+      def verify_checksums_signature!(asset_url, checksums_path, tmpdir)
+        cosign = find_executable("cosign")
+        return unless cosign
+
+        signature_path = File.join(tmpdir, "SHA256SUMS.sig")
+        certificate_path = File.join(tmpdir, "SHA256SUMS.pem")
+        download_asset(
+          sibling_asset_url(asset_url, "SHA256SUMS.sig"), signature_path,
+          max_bytes: MAX_CHECKSUM_ASSET_BYTES
+        )
+        download_asset(
+          sibling_asset_url(asset_url, "SHA256SUMS.pem"), certificate_path,
+          max_bytes: MAX_CHECKSUM_ASSET_BYTES
+        )
+        identity = "^https://github\\.com/#{Regexp.escape(Hive::REPO_OWNER)}/#{Regexp.escape(Hive::REPO_NAME)}/"
+        _out, err, status = @subprocess_runner.call(
+          cosign, "verify-blob",
+          "--certificate", certificate_path,
+          "--signature", signature_path,
+          "--certificate-identity-regexp", identity,
+          "--certificate-oidc-issuer", "https://token.actions.githubusercontent.com",
+          checksums_path,
+          timeout: DEFAULT_CHECKSUM_VERIFY_TIMEOUT
+        )
+        return if status.success?
+
+        raise Error, "cosign verification failed for SHA256SUMS: #{err.to_s.strip}"
+      rescue Hive::BoundedSubprocess::TimeoutError
+        raise Error, "cosign verification timed out after #{DEFAULT_CHECKSUM_VERIFY_TIMEOUT}s"
+      end
+
+      def find_executable(name)
+        @env["PATH"].to_s.split(File::PATH_SEPARATOR).each do |dir|
+          candidate = File.join(dir, name)
+          return candidate if File.file?(candidate) && File.executable?(candidate)
+        end
+        nil
+      end
+
+      def default_bundle_install(app_dir)
+        gemfile = File.join(app_dir, "Gemfile")
+        return unless File.file?(gemfile)
+
+        env = bundle_env(app_dir)
+        # Prefer frozen install when Gemfile.lock is present; fall back to a
+        # network-enabled install when the release's vendor/cache does not
+        # contain every platform-specific Rails dependency.
+        cmd =
+          if File.file?(File.join(app_dir, "Gemfile.lock"))
+            %w[bundle install --local]
+          else
+            %w[bundle install]
+          end
+
+        out, err, status = run_bundle_install(env, cmd, app_dir)
+        return if status.success?
+
+        # --local can fail when vendor/cache does not hold every dependency;
+        # retry without it once while preserving the same hard deadline.
+        if cmd.include?("--local")
+          out, err, status = run_bundle_install(env, %w[bundle install], app_dir)
+          return if status.success?
+        end
+
+        detail = [ out, err ].map(&:to_s).map(&:strip).reject(&:empty?).join("\n")
+        raise Error, "bundle install failed for web app at #{app_dir}: #{detail}"
+      end
+
+      def bundle_env(app_dir)
+        {
+          # Point Bundler's app-local config lookup at the managed tree. A
+          # caller-level BUNDLE_APP_CONFIG can otherwise load a path setting
+          # that outranks BUNDLE_PATH and sends gems back into the CLI bundle.
+          "BUNDLE_APP_CONFIG" => File.join(app_dir, ".bundle"),
+          "BUNDLE_GEMFILE" => File.join(app_dir, "Gemfile"),
+          "BUNDLE_PATH" => File.join(app_dir, "vendor", "bundle"),
+          "BUNDLE_DEPLOYMENT" => "1",
+          "BUNDLE_WITHOUT" => "development:test",
+          "RAILS_ENV" => "production"
+        }
+      end
+
+      def run_bundle_install(env, cmd, app_dir)
+        @subprocess_runner.call(env, *cmd, chdir: app_dir, timeout: @bundle_timeout)
+      rescue Hive::BoundedSubprocess::TimeoutError
+        raise Error, "bundle install timed out after #{@bundle_timeout}s for web app at #{app_dir}"
+      end
+
+      def missing_bundle_message
+        "hive web: no Rails app found. Install the matching release asset " \
+          "(#{archive_basename}) under #{managed_app_dir}, run from a source " \
+          "checkout, or set #{ENV_APP_DIR} to a Rails app directory."
+      end
+    end
+  end
+end
diff --git a/lib/hive/web/dispatcher.rb b/lib/hive/web/dispatcher.rb
index 10683729..93c77f4f 100644
--- a/lib/hive/web/dispatcher.rb
+++ b/lib/hive/web/dispatcher.rb
@@ -11,6 +11,29 @@ require "hive/stages"
 module Hive
   module Web
     class Dispatcher
+      # Enqueue the only allowlisted host-maintenance command so a running
+      # daemon rewrites its unit with the current CLI binary. Rails workers
+      # never shell out to rewrite services themselves.
+      def queue_daemon_repair!
+        require "hive/daemon/dispatch_request_queue"
+        argv = Hive::Daemon::DispatchRequestQueue::MAINTENANCE_ARGV.dup
+        unless Hive::Daemon::DispatchRequestQueue.valid_argv?(
+          argv,
+          project: Hive::Daemon::DispatchRequestQueue::GLOBAL_PROJECT,
+          slug: Hive::Daemon::DispatchRequestQueue::GLOBAL_SLUG
+        )
+          raise Hive::Error, "daemon repair argv is not allowlisted"
+        end
+
+        Hive::Daemon::DispatchRequestQueue.write_request!(
+          project: Hive::Daemon::DispatchRequestQueue::GLOBAL_PROJECT,
+          slug: Hive::Daemon::DispatchRequestQueue::GLOBAL_SLUG,
+          argv: argv,
+          requestor: "bot",
+          trigger: "daemon_repair"
+        )
+      end
+
       STAGE_VERB_BY_ACTION = {
         "ready_to_brainstorm" => "brainstorm",
         "ready_to_plan" => "plan",
diff --git a/lib/hive/web/loopback.rb b/lib/hive/web/loopback.rb
new file mode 100644
index 00000000..0d97717b
--- /dev/null
+++ b/lib/hive/web/loopback.rb
@@ -0,0 +1,52 @@
+# frozen_string_literal: true
+
+require "ipaddr"
+
+module Hive
+  module Web
+    # Shared loopback classifier used by the CLI bind gate (`hive web`) and
+    # the Rails request auth bypass. One implementation so the two sides
+    # cannot disagree about what counts as loopback.
+    module Loopback
+      module_function
+
+      # Environment flag set by the CLI only when the configured bind is
+      # loopback AND config `web.local_loopback` is enabled. Rails re-checks
+      # the actual peer address before skipping login.
+      ENV_MODE = "HIVE_WEB_LOCAL_LOOPBACK"
+
+      # Hostnames treated as loopback when used as a bind address.
+      LOOPBACK_HOSTS = %w[localhost].freeze
+
+      def address?(value)
+        raw = value.to_s.strip
+        return false if raw.empty?
+        return true if LOOPBACK_HOSTS.include?(raw.downcase)
+
+        # Strip IPv6 brackets: "[::1]"
+        host = raw.sub(/\A\[(.*)\]\z/, '\1')
+        # Strip optional :port for IPv4 ("127.0.0.1:4567") — not for IPv6.
+        if host.count(":") == 1 && host.match?(/\A[\d.]+:\d+\z/)
+          host = host.split(":", 2).first
+        end
+
+        ip = IPAddr.new(host)
+        ip.loopback?
+      rescue IPAddr::InvalidAddressError, IPAddr::AddressFamilyError
+        false
+      end
+
+      def mode_enabled?(env = ENV)
+        %w[1 true yes].include?(env[ENV_MODE].to_s.strip.downcase)
+      end
+
+      def enable_mode!(env = ENV)
+        env[ENV_MODE] = "1"
+      end
+
+      def disable_mode!(env = ENV)
+        env.delete(ENV_MODE)
+      end
+    end
+  end
+end
diff --git a/test/integration/daemon_stale_agent_healing_test.rb b/test/integration/daemon_stale_agent_healing_test.rb
index eeb25d12..d3c7999e 100644
--- a/test/integration/daemon_stale_agent_healing_test.rb
+++ b/test/integration/daemon_stale_agent_healing_test.rb
@@ -123,7 +123,9 @@ class DaemonStaleAgentHealingTest < Minitest::Test
         request = pending.find { |r| r.slug == slug }
         refute_nil request,
                    "the rerun must land in the REAL queue (argv allowlist, slug grammar, kwargs contract)"
-        assert Hive::Daemon::DispatchRequestQueue.valid_argv?(request.argv),
+        assert Hive::Daemon::DispatchRequestQueue.valid_argv?(
+          request.argv, project: request.project, slug: request.slug
+        ),
                "the queued argv must pass the dispatcher's allowlist"
         assert_equal [ "hive", "plan", slug, "--project", File.basename(dir), "--from", "3-plan" ],
                      request.argv
